首页 > 代码库 > HDU 1051: Wooden Sticks(贪心)
HDU 1051: Wooden Sticks(贪心)
Wooden Sticks
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 11244 Accepted Submission(s): 4627
Problem Description
There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the machine to prepare processing a stick. The setup times are associated with cleaning operations and changing tools and shapes in the machine. The setup times of the woodworking machine are given as follows:
(a) The setup time for the first wooden stick is 1 minute.
(b) Right after processing a stick of length l and weight w , the machine will need no setup time for a stick of length l‘ and weight w‘ if l<=l‘ and w<=w‘. Otherwise, it will need 1 minute for setup.
You are to find the minimum setup time to process a given pile of n wooden sticks. For example, if you have five sticks whose pairs of length and weight are (4,9), (5,2), (2,1), (3,5), and (1,4), then the minimum setup time should be 2 minutes since there is a sequence of pairs (1,4), (3,5), (4,9), (2,1), (5,2).
(a) The setup time for the first wooden stick is 1 minute.
(b) Right after processing a stick of length l and weight w , the machine will need no setup time for a stick of length l‘ and weight w‘ if l<=l‘ and w<=w‘. Otherwise, it will need 1 minute for setup.
You are to find the minimum setup time to process a given pile of n wooden sticks. For example, if you have five sticks whose pairs of length and weight are (4,9), (5,2), (2,1), (3,5), and (1,4), then the minimum setup time should be 2 minutes since there is a sequence of pairs (1,4), (3,5), (4,9), (2,1), (5,2).
Input
The input consists of T test cases. The number of test cases (T) is given in the first line of the input file. Each test case consists of two lines: The first line has an integer n , 1<=n<=5000, that represents the number of wooden sticks in the test case, and the second line contains n 2 positive integers l1, w1, l2, w2, ..., ln, wn, each of magnitude at most 10000 , where li and wi are the length and weight of the i th wooden stick, respectively. The 2n integers are delimited by one or more spaces.
Output
The output should contain the minimum setup time in minutes, one per line.
Sample Input
3 5 4 9 5 2 2 1 3 5 1 4 3 2 2 1 1 2 2 3 1 3 2 2 3 1
Sample Output
2 1 3
题意是第一个3是3组数据, 然后一个5是5根棍子, 然后逐一输入其的长度和重量。。题目是问怎么做这些棍子用时最少,在做棍子时,若后一根棍子,长度和重量都大于前
一根,则不用加时间。。
想法。。
拿第一组数据来说。。
首先按长度以小到大排序:(1,4),(2,1),(3, 5), (4, 9),(5,2);
我们发现(2, 1)的重量太小, 而(5, 2)的长度太长。这样排结果为3;
其实这时,我们只要把不满足的先标记起来。。
则(1,4),(3,5),(4,9) ———— (2,1), (5,2)
但我们这么排, 也就是题目给出的顺序,结果就为2;也就是最优。
#include<cstdio> #include<cstring> #include<iostream> #include<algorithm> #include<vector> #include<queue> #include<sstream> #include<cmath> using namespace std; #define M 100500 struct node { int lenth; int weight; int k; } Q[M]; bool cmp ( node a, node b ) { if(a.lenth==b.lenth) return a.weight<b.weight; else return a.lenth<b.lenth; } int main() { int t; int n; scanf("%d", &t); while( t-- ) { scanf("%d", &n); for(int i=0; i<n; i++) { scanf("%d%d", &Q[i].lenth, &Q[i].weight); Q[i].k= 1; } sort( Q, Q+n, cmp ); int ans = 0; for(int i=0; i<n-1; i++) { if(!Q[i].k) continue; int t = Q[i].weight; for(int j = i+1; j<n; j++) if(Q[j].weight>=t &&Q[j].k==1 ) { ans++; Q[j].k=0; t = Q[j].weight; } } printf("%d\n", n-ans); } return 0; }
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。